#include <fstream>
using namespace std;

ifstream fin("componenteconexe.in");
ofstream fout("componenteconexe.out");

const int MaxN = 101;
bool a[MaxN][MaxN];
int n;
int v[MaxN];
int nrc; // nr de componente conexe

void ReadGraph();
void Df(int x);

int main()
{
    ReadGraph();

    for (int x = 1; x <= n; ++x)
        if (!v[x]) // x e nevizitat inca
        {
            nrc++;
            Df(x);
        }

    fout << nrc << '\n';

    for (int c = 1; c <= nrc; ++c) // pt fiecare comp conexa c
    {
        for (int nod = 1; nod <= n; ++nod)
            if (v[nod] == c)
                fout << nod << ' ';
        fout << '\n';
    }


    fin.close();
    fout.close();
}

void ReadGraph()
{
    fin >> n;
    int x, y;
    while (fin >> x >> y)
        a[x][y] = a[y][x] = true;
}

void Df(int x)
{
    v[x] = nrc;
    for (int y = 1; y <= n; ++y)
        if (a[x][y] && !v[y])
            Df(y);
}


