#include <fstream>
using namespace std;

ifstream fin("componenteconexe2.in");
ofstream fout("componenteconexe2.out");

const int MaxN = 101;
bool a[MaxN][MaxN];
int n;
bool v[MaxN];
int niv[MaxN];    // niv[x] = nivelul nodului x in arborele DFS
int NR;     // nr max de muchii care pot fi eliminate

void ReadGraph();
void Df(int x, int tata);

int main()
{
    ReadGraph();

    for (int x = 1; x <= n; ++x)
        if (!v[x]) // am gasit o noua comp conexa
            Df(x, 0);

    fout << NR;
    fin.close();
    fout.close();
}

void ReadGraph()
{
    fin >> n;
    int x, y;
    while (fin >> x >> y)
        a[x][y] = a[y][x] = true;
}

void Df(int x, int tata)
{
    v[x] = true;
    niv[x] = niv[tata] + 1;
    for (int y = 1; y <= n; ++y)
        if (a[x][y])
        {
            if (!v[y]) // muchie de arbore
                Df(y, x);
            else
                if (y != tata && niv[y] < niv[x])
                    NR++;
        }
}

