#include <fstream>
using namespace std;

ifstream fin("componenteconexe3.in");
ofstream fout("componenteconexe3.out");

const int MaxN = 101;
bool a[MaxN][MaxN];
int n;
bool v[MaxN];
int cnt;     // cnt = numarul de noduri din componenta conexa curenta
int cntMax;  // numarul de noduri din componenta conexa cu cele mai multe noduri
int nrc;     // nr de componente conexe
int R;       // reprezentantul comp conexe cu cele mai multe noduri
void ReadGraph();
void Df(int x);

int main()
{
    ReadGraph();

    for (int x = 1; x <= n; ++x)
        if (!v[x]) // x e nevizitat inca
        {
            cnt = 0;
            Df(x);
            if (cnt > cntMax)
            {
                cntMax = cnt;
                R = x;
            }
        }

    fout << R << ' ' << cntMax;

    fin.close();
    fout.close();
}

void ReadGraph()
{
    fin >> n;
    int x, y;
    while (fin >> x >> y)
        a[x][y] = a[y][x] = true;
}

void Df(int x)
{
    cnt++;
    v[x] = true;
    for (int y = 1; y <= n; ++y)
        if (a[x][y] && !v[y])
            Df(y);
}


